Bug 836151 - ACLiC broken by failure to link with libCint.so
ACLiC broken by failure to link with libCint.so
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: root (Show other bugs)
17
x86_64 Linux
unspecified Severity high
: ---
: ---
Assigned To: Mattias Ellert
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-28 04:51 EDT by nvwarr
Modified: 2012-07-15 14:26 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-07-08 16:52:28 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description nvwarr 2012-06-28 04:51:54 EDT
Description of problem:

When compiling with ACLiC from within root, it doesn't include libCint.so, so it fails with a long list of error messages. This breaks a large part of the functionality of root, since scripts can then only be interpreted not compiled.

Version-Release number of selected component (if applicable):

root-core-5.32.03-1.fc17.x86_64

How reproducible:

Always

Steps to Reproduce:
1. Create a simple program like hello.C as follows:
#include <iostream>
void hello() {cout << "hello, world!" << endl;}

2. From the root prompt:
.L hello.C++
  
Actual results:
Info in <TUnixSystem::ACLiC>: creating shared library /tmp/./hello_C.so
/tmp/hello_C_ACLiC_dict.o: In function `G__hello_C_ACLiC_dict__0_1290':
/tmp/hello_C_ACLiC_dict.cxx:72: undefined reference to `G__setnull'
/tmp/hello_C_ACLiC_dict.o: In function `G__get_sizep2memfunchello_C_ACLiC_dict()':
/tmp/hello_C_ACLiC_dict.cxx:99: undefined reference to `G__setsizep2memfunc'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_typetablehello_C_ACLiC_dict':
/tmp/hello_C_ACLiC_dict.cxx:124: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:124: undefined reference to `G__search_typename2'
/tmp/hello_C_ACLiC_dict.cxx:125: undefined reference to `G__setnewtype'
/tmp/hello_C_ACLiC_dict.cxx:126: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:126: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:126: undefined reference to `G__search_typename2'
/tmp/hello_C_ACLiC_dict.cxx:127: undefined reference to `G__setnewtype'
/tmp/hello_C_ACLiC_dict.cxx:128: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:128: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:128: undefined reference to `G__search_typename2'
/tmp/hello_C_ACLiC_dict.cxx:129: undefined reference to `G__setnewtype'
/tmp/hello_C_ACLiC_dict.cxx:130: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:130: undefined reference to `G__search_typename2'
/tmp/hello_C_ACLiC_dict.cxx:131: undefined reference to `G__setnewtype'
/tmp/hello_C_ACLiC_dict.cxx:132: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:132: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:132: undefined reference to `G__search_typename2'
/tmp/hello_C_ACLiC_dict.cxx:133: undefined reference to `G__setnewtype'
/tmp/hello_C_ACLiC_dict.cxx:134: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:134: undefined reference to `G__get_linked_tagnum'
/tmp/hello_C_ACLiC_dict.cxx:134: undefined reference to `G__search_typename2'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_global0':
/tmp/hello_C_ACLiC_dict.cxx:170: undefined reference to `G__resetplocal'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_func0':
/tmp/hello_C_ACLiC_dict.cxx:187: undefined reference to `G__lastifuncposition'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_func12':
/tmp/hello_C_ACLiC_dict.cxx:226: undefined reference to `G__memfunc_setup'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_tagtablehello_C_ACLiC_dict':
/tmp/hello_C_ACLiC_dict.cxx:268: undefined reference to `G__get_linked_tagnum_fwd'
/tmp/hello_C_ACLiC_dict.cxx:269: undefined reference to `G__get_linked_tagnum_fwd'
/tmp/hello_C_ACLiC_dict.cxx:270: undefined reference to `G__get_linked_tagnum_fwd'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setuphello_C_ACLiC_dict':
/tmp/hello_C_ACLiC_dict.cxx:274: undefined reference to `G__check_setup_version'
/tmp/hello_C_ACLiC_dict.cxx:288: undefined reference to `G__getsizep2memfunc'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_typetablehello_C_ACLiC_dict':
/tmp/hello_C_ACLiC_dict.cxx:135: undefined reference to `G__setnewtype'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_global1':
/tmp/hello_C_ACLiC_dict.cxx:176: undefined reference to `G__resetglobalenv'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_func12':
/tmp/hello_C_ACLiC_dict.cxx:228: undefined reference to `G__resetifuncposition'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_tagtablehello_C_ACLiC_dict':
/tmp/hello_C_ACLiC_dict.cxx:271: undefined reference to `G__get_linked_tagnum_fwd'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_inithello_C_ACLiC_dict::~G__cpp_setup_inithello_C_ACLiC_dict()':
/tmp/hello_C_ACLiC_dict.cxx:294: undefined reference to `G__remove_setup_func'
/tmp/hello_C_ACLiC_dict.o: In function `G__cpp_setup_inithello_C_ACLiC_dict':
/tmp/hello_C_ACLiC_dict.cxx:293: undefined reference to `G__add_setup_func'
/tmp/hello_C_ACLiC_dict.cxx:293: undefined reference to `G__call_setup_funcs'
collect2: error: ld returned 1 exit status
Error in <ACLiC>: Compilation failed!

i.e. it is missing all the functions from libCint.so

Expected results:

should compile and add the function hello, which can then be called from the root prompt.

Additional info:

Workaround: gSystem->Load("libCint.so") before compiling ensures that libCint.so is already loaded, so the compilation works.

Link: http://code.compeng.uni-frankfurt.de/projects/root/repository/revisions/d33118a47b082eb6d88a64b5e31413a1e6dd8527

Making the changes suggested by the diff in that link fixes the problem for me.
Comment 1 Steve Traylen 2012-06-28 05:11:00 EDT
yum provides '*/libCint.so'


root-cint-5.28.00h-1.el6.i686 : CINT C++ interpreter
Repo        : epel
Matched from:
Filename    : /usr/lib/root/libCint.so


do you have the root-cint package installed?
Comment 2 Steve Traylen 2012-06-28 05:12:43 EDT
Ignore my last comment, you must have it installed.
Comment 3 nvwarr 2012-06-29 01:28:34 EDT
I have root-cint-5.32.03-1.fc17.x86_64 from F17, but as you obviously realised 103 seconds later, the workaround wouldn't have worked without it:)
Comment 4 Fedora Update System 2012-06-29 08:22:17 EDT
root-5.28.00h-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/root-5.28.00h-2.el6
Comment 5 Fedora Update System 2012-06-29 08:22:27 EDT
root-5.32.03-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/root-5.32.03-2.fc17
Comment 6 Fedora Update System 2012-06-29 08:22:36 EDT
root-5.28.00h-2.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/root-5.28.00h-2.el5
Comment 7 Fedora Update System 2012-06-29 08:22:45 EDT
root-5.30.06-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/root-5.30.06-3.fc16
Comment 8 Fedora Update System 2012-06-30 18:09:13 EDT
Package root-5.32.03-2.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing root-5.32.03-2.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-10116/root-5.32.03-2.fc17
then log in and leave karma (feedback).
Comment 9 Fedora Update System 2012-07-08 16:52:28 EDT
root-5.32.03-2.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 Fedora Update System 2012-07-08 16:54:24 EDT
root-5.30.06-3.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2012-07-15 14:25:56 EDT
root-5.28.00h-2.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2012-07-15 14:26:52 EDT
root-5.28.00h-2.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.